-- Test translate_amenity_feature
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(14);

set search_path to camper, public;

select has_function('camper', 'translate_amenity_feature', array['integer', 'text', 'text']);
select function_lang_is('camper', 'translate_amenity_feature', array['integer', 'text', 'text'], 'sql');
select function_returns('camper', 'translate_amenity_feature', array['integer', 'text', 'text'], 'void');
select isnt_definer('camper', 'translate_amenity_feature', array['integer', 'text', 'text']);
select volatility_is('camper', 'translate_amenity_feature', array['integer', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'translate_amenity_feature', array['integer', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'translate_amenity_feature', array['integer', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'translate_amenity_feature', array['integer', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'translate_amenity_feature', array['integer', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate amenity_feature_i18n cascade;
truncate amenity_feature cascade;
truncate amenity cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into amenity (amenity_id, company_id, label, name)
values (4, 1, 'A1', 'Amenity A1')
;

insert into amenity_feature (amenity_feature_id, amenity_id, icon_name, name)
values (5, 4, 'toilet', 'Feature 1')
     , (6, 4, 'toilet', 'Feature 2')
;

insert into amenity_feature_i18n (amenity_feature_id, lang_tag, name)
values (6, 'ca', 'carácter2')
;

select lives_ok(
	$$ select translate_amenity_feature(5, 'ca', 'Carácter 1') $$,
	'Should be able to translate the first feature'
);

select lives_ok(
	$$ select translate_amenity_feature(6, 'es', 'Característica 2') $$,
	'Should be able to translate the second feature'
);

select lives_ok(
	$$ select translate_amenity_feature(6, 'en', '') $$,
	'Should be able to “translate” the second feature with an empty translation'
);

select lives_ok(
	$$ select translate_amenity_feature(6, 'ca', 'Carácter 2') $$,
	'Should be able to overwrite the catalan translation of the second feature'
);

select bag_eq(
	$$ select amenity_feature_id, lang_tag, name from amenity_feature_i18n $$,
	$$ values (5, 'ca', 'Carácter 1')
	        , (6, 'ca', 'Carácter 2')
	        , (6, 'es', 'Característica 2')
	        , (6, 'en', null)
	$$,
	'Should have added and updated all translations.'
);


select *
from finish();

rollback;
